/*
	$Id: PropertyFilter.java 6127 2012-09-14 07:28:35Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.taglib.table;


import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.tagext.Tag;
import javax.servlet.jsp.tagext.TagSupport;

/**
	Special tag for outputting the filter HTML that a {@link ColumnDef} has
	registered with the {@link Table} object.
	

	@author Nicklas
	@version 2.0
*/
public class PropertyFilter
	extends TagSupport
{

	/**
		
	*/
	private static final long serialVersionUID = -1007580995461268459L;
	/**
		The parent &lt;tbl:table&gt; tag.
	*/
	private Table table;


	/*
		Package methods
	*/
	Table getTable()
	{
		return table;
	}

	/*
		Display methods
	*/
	@Override
	public int doStartTag()
		throws JspException
	{
		table = (Table)findAncestorWithClass(this, Table.class);
		try
		{
			int numColumns = table.writeColumnFilters();
			Tag parent = getParent();
			if (parent instanceof HeaderRow)
			{
				HeaderRow hr = (HeaderRow)parent;
				hr.addHeaderColumns(numColumns);
			}
		}
		catch (Exception ex)
		{
			throw new JspTagException(ex.getMessage());
		}
		return SKIP_BODY;
	}
	
}

