/*
	$Id: DatabaseException.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Samuel Andersson, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	Exceptions of this type are thrown when there is an error
	from the database.

	@author Samuel
	@version 2.0
*/
public class DatabaseException
	extends BaseException
{
	/**
		
	*/
	private static final long serialVersionUID = -8341857688856615743L;

	/**
		Create a new <code>DatabaseException</code> object.
	*/
	public DatabaseException()
	{
		super();
	}

	/**
		Create a new <code>DatabaseException</code> object with the 
		specified <code>message</code>.

		@param message The message to throw with the exception
	*/
	public DatabaseException(String message)
	{
		super(message);
	}
	
	/**
		Create a new <code>DatabaseException</code> object with the 
		specified <code>message</code>
		@param message The message to throw with the exception
		@param cause The original exception
	*/
	public DatabaseException(String message, Throwable cause)
	{
		super(message, cause);
	}

	/**
		Create a new <code>DatabaseException</code> object acting as a 
		wrapper for another exception that caused the error.
		@param cause The original exception
	*/
	public DatabaseException(Throwable cause)
	{
		this(cause.getMessage(), cause);
	}
}
