/*
  $Id $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.
	
	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.Set;

/**
	A permission template with permissions to users, groups and 
	projects.
	
	@author Nicklas
	@since 2.16
	@see net.sf.basedb.core.PermissionTemplate
	@hibernate.class table="`PermissionTemplates`" lazy="true"
	@base.modified $Date $
	@see <a href="../../../../../../html/developer/api/data_api.authentication.html">Developer documentation: User authentication</a>
*/
public class PermissionTemplateData
	extends CommonData
{
	public PermissionTemplateData()
	{}

	private Set<ProjectData> projects;
	/**
		This is the inverse end.
		@see ProjectData#getPermissionTemplate()
		@hibernate.set inverse="true" lazy="true"
		@hibernate.collection-key column="`permissiontemplate_id`"
		@hibernate.collection-one-to-many class="net.sf.basedb.core.data.ProjectData"
	*/
	Set<ProjectData> getProjects()
	{
		return projects;
	}
	void setProjects(Set<ProjectData> projects)
	{
		this.projects = projects;
	}

}
