/*
	$Id: UserRoles.java 6127 2012-09-14 07:28:35Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data.keyring;
import java.io.Serializable;

/**
	Class for mapping the <code>UserRoles</code> table.
	@author Nicklas
	@version 2.0
	@base.modified $Date: 2012-09-14 09:28:35 +0200 (fr, 14 sep 2012) $
*/
public final class UserRoles
	implements Serializable
{
	/**
		
	*/
	private static final long serialVersionUID = -4810248574594702409L;
	private int userId;
	private int roleId;
	
	/**
		Create a new <code>UserRoles</code> object.
	*/
	public UserRoles()
	{}

	/**
		Get the id of the user.
	*/
	public int getUserId()
	{
		return userId;
	}
	/**
		Set the id of the user.
	*/
	public void setUserId(int userId)
	{
		this.userId = userId;
	}
	/**
		Get the id of the role.
	*/
	public int getRoleId()
	{
		return roleId;
	}
	/**
		Set the id of the role.
	*/
	public void setRoleId(int roleId)
	{
		this.roleId = roleId;
	}

	/**
		Check if this object is equal to another <code>UserRoles</code>
		object. They are considered to be the same if the user id and the
		role id are the same.
	*/
	@Override
	public boolean equals(Object o)
	{
		if ((o == null) || (getClass() != o.getClass())) return false;
		UserRoles ur = (UserRoles)o;
		return (ur.userId == this.userId) && (ur.roleId == this.roleId);
	}
	
	/**
		Calculate the hash code for the object.
	*/
	@Override
	public int hashCode()
	{
		return (int)(31*userId + 17*roleId);
	}
}
