/**
	$Id $

	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.encode;

/**
	Encoder decoder implementation that doesn't encode or decode
	anything.

	@since 2.15
	@author Nicklas
*/
public class IdentityEncoderDecoder 
	implements EncoderDecoder 
{

	public IdentityEncoderDecoder()
	{}
	
	/*
		From the EncoderDecoder interface
		---------------------------------
	*/
	@Override
	public boolean isSymmetrical() 
	{
		return true;
	}
	
	@Override
	public String decode(String s) 
	{
		return s;
	}
	
	@Override
	public String encode(String s) 
	{
		return s;
	}
	// -------------------------------------------

}
