/**
	$Id: StaticFilter.java 4594 2008-10-21 07:20:40Z nicklas $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.filter;

/**
	A filter implementation that either rejects or accepts all
	object (including null).
	
	@author Nicklas
	@version 2.9
	@base.modified $Date: 2008-10-21 09:20:40 +0200 (ti, 21 okt 2008) $
*/
public class StaticFilter<T>
	implements Filter<T>
{

	private final boolean pass;
	
	/**
		Create a new filter. 
		@param pass TRUE if all objects should pass, FALSE if not
	*/
	public StaticFilter(boolean pass)
	{
		this.pass = pass;
	}

	@Override
	public boolean evaluate(T object)
	{
		return pass;
	}
	
}
