<%-- $Id: calendar.jsp 6607 2014-11-19 14:52:20Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	A window for selecting a date interactively from a calendar

	@param title The title of the input field on the parent form
	@param textarea The id of the input field containing the current date value

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
	final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
	String title = request.getParameter("title");
	String textarea = request.getParameter("textarea");
	boolean useTime = Values.getBoolean(request.getParameter("useTime"));
	
	String format = Values.getString(request.getParameter("format"), useTime ? FormatterSettings.getDateTimeFormat(sc) : FormatterSettings.getDateFormat(sc));
%>
<base:page type="popup" title="<%=title%>">
<base:head styles="calendar.css" scripts="~calendar.js" />
<base:body>
	<h1><%=title%><base:help helpid="calendar.selectday" /></h1>
	
	<div id="page-data" class="datacontainer"
		data-textarea="<%=textarea%>"
		data-date-format="<%=HTML.encodeTags(format) %>"
		data-use-time="<%=useTime ? 1 : 0 %>"
	></div>
	
	<form name="calendar">
	<div class="content bg-filled-50 bottomborder">

		<div style="position: absolute; top: 0px; left: 0px; right: 0px; height: 2em; text-align: center;">
			<table style="height: 100%; margin:auto;"><tr><td>
			<base:icon image="goback.png" id="prevMonth" />
			</td>
			<td style="width: 15em;">
			<b>
			<span id="month"></span>
			<span id="year"></span>
			</b>
			</td>
			<td>
			<base:icon image="gonext.png" id="nextMonth" />
			</td></tr></table>
		</div>

		<div style="position: absolute; top: 2em; bottom: <%=useTime ? "2" : "1" %>em; width: 100%;">
		<table class="calendar">
		<tr>
			<td class="day">Mon</td>
			<td class="day">Tue</td>
			<td class="day">Wed</td>
			<td class="day">Thu</td>
			<td class="day">Fri</td>
			<td class="day">Sat</td>
			<td class="day">Sun</td>
		</tr>
		<%
		for (int week = 1; week < 7; ++week)
		{
			%>
			<tr id="w<%=week%>" style="max-height: 1.5em;">
			<%
			for (int day = 0; day < 7; ++day)
			{
				%>
				<td id="w<%=week%>d<%=day%>" 
					class="date <%=day==6 ? "sunday" : ""%>" 
					data-week="<%=week%>" data-day="<%=day%>"
					tabindex="0"><%=day%></td>
				<%
			}
			%>
			</tr>
			<%
		}
		%>
		</table>
		</div>
		<%
		if (useTime)
		{
			%>
			<div style="position: absolute; height: 2em; left: 0px; right: 0px; bottom: 0em; text-align: center;">
			<table style="height: 100%; margin:auto;">
			<tr>
				<td class="time">Time</td>
				<td><input class="text" type="text" name="hours" id="hours" title="Hours" maxlength="2" style="width: 2em;">h</td>
				<td><input class="text" type="text" name="minutes" id="minutes" title="Minutes" maxlength="2" style="width: 2em;">m</td>
				<td><input class="text" type="text" name="seconds" id="seconds" title="Seconds" maxlength="2" style="width: 2em;">s</td>
			</tr>
			</table>
			</div>
			<%
		}
		%>
	</div>
	</form>
	
	
	<base:buttongroup subclass="dialogbuttons">
		<base:button id="btnToday" image="today.png" title="<%=useTime ? "Now" : "Today"%>" />
		<base:button id="btnSave" title="Ok" visible="<%=useTime%>"/>
		<base:button id="close" title="Cancel" />
	</base:buttongroup>
</base:body>
</base:page>
