<%-- $Id: menu.jsp 6617 2014-11-24 08:26:59Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson, Gregory Vincic
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page is included from the <base:page> taglib to display the
	meny.

	@param name
		The name of the menu to display:
		- standard: The standard menu for a logged in user
		- login: The menu used on pages where no user is logged in
		- exception: Used on error pages, does not display a menu at all
		- auto: Will display either the "standard" or "login" menu

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.StringUtil"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Order"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.resources.Bundle"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.resources.ResourceBundleWrapper"
	import="net.sf.basedb.util.resources.ResourceBundleFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.menu.MenuItemAction"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.ActionIterator"
	import="net.sf.basedb.clients.web.extensions.DynamicActionAttributes"
	import="net.sf.basedb.clients.web.extensions.DynamicActionAttribute"
	import="java.util.HashMap"
	import="java.util.Map"
	import="java.util.ArrayList"
	import="java.util.LinkedList"
	import="java.util.List"
	import="java.util.Arrays"
	import="java.util.Iterator"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final SessionControl sc = Base.getSessionControl(pageContext, false);
final String ID = sc == null ? "" : sc.getId();
String name = Values.getString(request.getParameter("name"), "login");
final String root = request.getContextPath()+"/";
if ("exception".equals(name) && sc != null && sc.isLoggedIn()) name = "standard";

final ResourceBundleWrapper common = ResourceBundleFactory.getResourceBundle(Bundle.COMMON, sc);
final ResourceBundleWrapper menu = ResourceBundleFactory.getResourceBundle(Bundle.MENU, sc);

if ("login".equals(name))
{
}
else if ("projects".equals(name) && sc != null && sc.isLoggedIn())
{
	// Projects menu
	int activeProjectId = sc.getActiveProjectId();
	%>
	<m:menu  
		id="menu.projects"
		style="display: none"
		>
		<%
		final DbControl dc = sc.newDbControl();
		boolean menuSeparatorBeforeDeactivate = true;
		try
		{
			List<Project> projects = new ArrayList<Project>();
			int lastRecentActiveIndex = 0;
			// 1. Load the most recently active projects
			String tmp = sc.getUserClientSetting("projects.recentActive");
			Set<Integer> recentProjects = new HashSet<Integer>();
			if (tmp != null)
			{
				for (String id : tmp.split(":"))
				{
					try
					{
						Project p = Project.getById(dc, Values.getInt(id));
						if (!p.isRemoved())
						{
							recentProjects.add(p.getId());
							projects.add(p);
							lastRecentActiveIndex++;
						}
					}
					catch (RuntimeException ex)
					{}
				}
			}
			
			// 2. Load more projects 
			final ItemContext projectCC = sc.getCurrentContext(Item.PROJECT);
			final ItemQuery<Project> projectQuery = Project.getQuery();
			projectQuery.include(Include.MINE, Include.SHARED);
			projectQuery.restrict(Restrictions.not(Restrictions.in(Hql.property("id"), Expressions.parameter("projects"))));
			projectQuery.setParameter("projects", recentProjects, Type.INT);
			Order projectSortOrder = projectCC.getSortOrder();
			if (projectSortOrder != null) projectQuery.order(projectSortOrder);
			projectQuery.order(Orders.asc(Hql.property("name")));
			projectQuery.setCacheResult(true);
			projects.addAll(projectQuery.list(dc));
			boolean breakAt15 = projects.size() > 16;
			int index = 0;
			String thisIsTheActiveProject = menu.getString("activeproject.tooltip");
			String thisIsNotTheActiveProject = menu.getString("inactiveproject.tooltip");
			if (lastRecentActiveIndex > 0)
			{
				%>
				<m:menuitem 
					title="<%=menu.getString("recentprojects.title")%>" 
					subclass="menusection"
					enabled="false" 
				/>
				<m:menuseparator />
				<%
			}
			Set<Integer> shownProjects = new HashSet<Integer>();
			for (Project p : projects)
			{
				if (index == 15 && breakAt15) break;
				index++;
				int projectId = p.getId();
				boolean active = activeProjectId == projectId;
				String prefix = index <= lastRecentActiveIndex ? index + ". " : "";
				shownProjects.add(p.getId());
				String url = active ? 
					root+"my_base/projects/index.jsp?ID="+ID+"&amp;cmd=ViewItem&amp;item_id=" + projectId : 
					root+"my_base/projects/set_active.jsp?ID="+ID+"&amp;project_id="+p.getId();
				%>
				<m:menuitem
					title="<%=prefix + HTML.encodeTags(p.getName())%>"
					subclass="active"
					url="<%=url%>"
					data-popup="<%=active ? "" : "ActivateProject, 300, 200"%>"
					icon="<%=active ? "checkedmenu.png" : null%>"
					tooltip="<%=active ? thisIsTheActiveProject : thisIsNotTheActiveProject%>"
				/>
				<%
				if (index == lastRecentActiveIndex)
				{
					%>
					<m:menuseparator />
					<%
					menuSeparatorBeforeDeactivate = false;
				}
				else
				{
					menuSeparatorBeforeDeactivate = true;
				}
			}
			if (breakAt15)
			{
				int more = projects.size() - 15;
				%>
				<m:menuitem 
					title="<%="…" + menu.getString("moreprojects.title", Integer.toString(more))%>"
					url="<%=root+"my_base/projects/index.jsp?ID="+ID+"&amp;cmd=UpdateContext&amp;tmpfilter:INT:id=<>"+Values.getString(shownProjects, "|", true)%>"
					tooltip="<%=menu.getString("moreprojects.tooltip")%>"
				/>
				<%
			}
		}
		catch (Throwable t)
		{
			t.printStackTrace();
			menuSeparatorBeforeDeactivate = false;
			%>
			<m:menuseparator />
			<m:menuitem 
				title="<%=menu.getString("projects.error.title")%>" 
				tooltip="<%=menu.getString("projects.error.tooltip", t.getMessage())%>"
				enabled="false"
				icon="error.png"
			/>
			<%
		}
		finally
		{
			if (dc != null) dc.close();
		}
		if (menuSeparatorBeforeDeactivate)
		{
			%>
			<m:menuseparator />
			<%
		}
		%>
		<m:menuitem
			title="<%="<i>- " + menu.getString("noactiveproject.title") + " -</i>"%>"
			url="<%=root+"my_base/projects/set_active.jsp?ID="+ID%>"
			data-popup="ActivateProject, 300, 200"
			icon="<%=activeProjectId == 0 ? "checkedmenu.png" : null%>"
			enabled="<%=activeProjectId != 0%>"
			tooltip="<%=menu.getString("noactiveproject.tooltip", activeProjectId == 0)%>"
		/>
	</m:menu>
	<%
}
else if ("recentItems".equals(name) && sc != null && sc.isLoggedIn())
{
	// Recently used items menu
	String stickyItems = Values.getString(sc.getUserClientSetting("menu.mostRecent"), 
		"EXPERIMENT:BIOASSAYSET:TRANSFORMATION");
	boolean loadNames = Values.getBoolean(sc.getUserClientSetting("menu.mostRecent.loadNames"), 
		true);
	String recentItems = sc.getUserClientSetting("menu.mostRecent.viewed");
	DbControl dc = loadNames ? sc.newDbControl() : null;
	try
	{
		%>
		<m:menu
			id="menu.mostRecent"
			style="display: none;"
			>
			<%
			int numItems = 0;
			// Recently viewed items
			List<String> recentlyViewed = recentItems == null ? 
				new ArrayList<String>() : Arrays.asList(recentItems.split(":"));
			if (recentlyViewed.size() > 0)
			{
				%>
				<m:menuitem 
					title="<%=menu.getString("recentitems.title")%>" 
					subclass="menusection"
					enabled="false" 
				/>
				<m:menuseparator />
				<%
				for (String recent : recentlyViewed)
				{
					try
					{
						String[] tmp = recent.split("=");
						Item itemType = Item.valueOf(tmp[0]);
						String itemTextKey = "item." + itemType.name().toLowerCase();
						String itemText = common.getString(itemTextKey);
						if (itemText == itemTextKey) itemText = itemType.toString();
						int itemId = Values.getInt(tmp[1], 0);
						if (itemId != 0)
						{
							String shortName = "";
							String fullName = "";
							int noEdit = 1;
							if (loadNames)
							{
								try
								{
									BasicItem item = itemType.getById(dc, itemId);
									fullName = ((Nameable)item).getName();
									shortName = HTML.encodeTags(StringUtil.trimString(fullName, 35));
									noEdit = item.hasPermission(Permission.WRITE) ? 0 : 1;
								}
								catch (Throwable t)
								{
									continue;
								}
							}
							else
							{
								fullName = itemText + "; id=" + itemId;
								shortName = itemText + " (id=" + itemId + ")";
							}
							numItems++;
							%>
							<m:menuitem
								title="<%=numItems + ". " + shortName%>"
								subclass="auto-init"
								data-auto-init="item-link"
								data-item-type="<%=itemType.name() %>"
								data-item-id="<%=itemId %>"
								data-no-edit="<%=noEdit %>"
								tooltip="<%=menu.getString("gotorecentitem.tooltip", fullName, itemText)%>"
							/>
							<%
						}
					}
					catch (Throwable t)
					{}
				}
			}
			if (stickyItems != null && stickyItems.length() > 0)
			{
				int numSticky = 0;
				if (numItems > 0)
				{
					%>
					<m:menuseparator />
					<%
				}
				%>
				<m:menuitem 
					title="<%=menu.getString("stickyitems.title")%>" 
					subclass="menusection"
					enabled="false" 
				/>
				<m:menuseparator />
				<%
				// Sticky items
				for (String recentItem : stickyItems.split(":"))
				{
					try
					{
						BasicItem item = null;
						Item itemType = Item.valueOf(recentItem);
						ItemContext cc = sc.getCurrentContext(itemType);
						String itemTextKey = "item." + itemType.name().toLowerCase();
						String itemText = common.getString(itemTextKey);
						if (itemText == itemTextKey) itemText = itemType.toString();
						if (cc.getId() != 0)
						{
							String shortName = "";
							String fullName = "";
							int noEdit = 1;
							if (loadNames)
							{
								try
								{
									item = itemType.getById(dc, cc.getId());
									fullName = ((Nameable)item).getName();
									shortName = ": " + HTML.encodeTags(StringUtil.trimString(fullName, 30));
									noEdit = item.hasPermission(Permission.WRITE) ? 0 : 1;
								}
								catch (Throwable t)
								{
									continue;
								}
							}
							else
							{
								fullName = itemText + "; id=" + cc.getId();
								shortName = " (id=" + cc.getId() + ")";
							}
							numItems++;
							numSticky++;
							%>
							<m:menuitem
								title="<%=itemText + shortName%>"
								subclass="auto-init"
								data-auto-init="item-link"
								data-item-type="<%=itemType.name() %>"
								data-item-id="<%=cc.getId() %>"
								data-no-edit="<%=noEdit %>"
								tooltip="<%=menu.getString("gotorecentitem.tooltip", fullName, itemText)%>"
							/>
							<%
							if (itemType == Item.BIOASSAYSET)
							{
								// Add menu for Experiment explorer as well
								%>
								<m:menuitem
									title="<%=menu.getString("experimentexplorer.title", shortName)%>"
									url="<%=root+"views/experiments/explorer/view/index.jsp?ID=" + ID + "&amp;bioassayset_id="+cc.getId()%>"
									tooltip="<%=menu.getString("experimentexplorer.tooltip")%>"
									visible="<%=item == null || ((BioAssaySet)item).getNumSpots() > 0 %>"
								/>
								<%
							}
						}
					}
					catch (Throwable t)
					{}
				}
				if (numSticky == 0)
				{
					%>
					<m:menuitem 
						title="<%="<i>- " + menu.getString("nostickyitems.title") + " -</i>"%>"
						enabled="false"
					/>
					<%
				}
			}
			%>
			<m:menuseparator />
			<m:menuitem 
				title="<%=menu.getString("recentoptions.title") + "…"%>" 
				url="<%=root+"my_base/user/preferences.jsp?ID="+ID+"&amp;page=mostRecent"%>"
				data-popup="Preferences, 600, 400"
				tooltip="<%=menu.getString("recentoptions.tooltip")%>" 
			/>
		</m:menu>
		<%
	}
	finally
	{
		if (dc != null) dc.close();
	}
}
else if ("standard".equals(name))
{
	final DbControl dc = sc.newDbControl();
	StringBuilder fillText = new StringBuilder();
	try
	{
		Project activeProject = sc.getActiveProjectId() == 0 ? null : Project.getById(dc, sc.getActiveProjectId());
		if (activeProject == null)
		{
			fillText.append("<img src=\""+root+"images/no_active_project.png\" alt=\"\">&nbsp;");
			fillText.append("<span style=\"color:#FF0000;\" title=\"" + menu.getString("menu.projects.tooltip.0") + "\"");
		}
		else
		{
			fillText.append("<img src=\""+root+"images/project.png\" alt=\"\">&nbsp;");
			fillText.append("<span title=\"" + menu.getString("menu.projects.tooltip.1") + "\"");
		}
		
		fillText.append(" class=\"link auto-init\" data-auto-init=\"menu-anchor\" data-menu-id=\"menu.projects\" data-align-right=\"1\">");
		fillText.append(activeProject == null ? "<i>" + menu.getString("noactiveproject.title") + "</i>" : HTML.encodeTags(activeProject.getName()));
		fillText.append("<img src=\""+root+"images/sort_asc.png\" alt=\"▼\"></span><span class=\"menuseparator\"></span>");
		
		fillText.append("<span id=\"page-reload\" class=\"link\" title=\"" + menu.getString("menu.refresh.tooltip") + "\">");
		fillText.append("<img src=\""+root+"images/refresh.png\" alt=\"Reload\"></span>");
		fillText.append("<span class=\"menuseparator\"></span>");
		
		fillText.append("<span class=\"link auto-init\" title=\"").append(menu.getString("menu.recentitems.tooltip")).append("\"");
		fillText.append(" data-auto-init=\"menu-anchor\" data-menu-id=\"menu.mostRecent\" data-align-right=\"1\">");
		fillText.append("<img src=\""+root+"images/recent.png\" alt=\"Recent\"><img src=\""+root+"images/sort_asc.png\" alt=\"▼\"></span>");
		fillText.append("<span class=\"menuseparator\"></span>");
		
		User user = User.getById(dc, sc.getLoggedInUserId());
		fillText.append("<img src=\""+root+"images/take_ownership.png\" alt=\"\">&nbsp;");
		fillText.append("<span class=\"link auto-init\" title=\"").append(menu.getString("menu.user.tooltip")).append("\"");
		fillText.append(" data-auto-init=\"menu-anchor\" data-menu-id=\"menu.switchuser\" data-align-right=\"1\">");
		fillText.append(HTML.encodeTags(user.getLogin()));
		fillText.append(" (").append(user.getName()).append(")<img src=\""+root+"images/sort_asc.png\" alt=\"▼\"></span>");

		// Permission settings
		final boolean hasFiles              = !sc.hasPermission(Permission.DENIED, Item.FILE);
		final boolean createFiles           =  sc.hasPermission(Permission.CREATE, Item.FILE);
		final boolean hasFileServers        = !sc.hasPermission(Permission.DENIED, Item.FILESERVER);

		final boolean hasProjects           = !sc.hasPermission(Permission.DENIED, Item.PROJECT); 
		final boolean createProjects        =  sc.hasPermission(Permission.CREATE, Item.PROJECT); 
		final boolean hasPermissionTemplates = !sc.hasPermission(Permission.DENIED, Item.PERMISSIONTEMPLATE); 

		final boolean hasMessages           = !sc.hasPermission(Permission.DENIED, Item.MESSAGE); 
		final boolean createMessages        =  sc.hasPermission(Permission.CREATE, Item.MESSAGE); 

		final boolean hasPhysicalBioAssays  = !sc.hasPermission(Permission.DENIED, Item.PHYSICALBIOASSAY); 
		final boolean hasDerivedBioAssays   = !sc.hasPermission(Permission.DENIED, Item.DERIVEDBIOASSAY); 

		final boolean hasRawBioAssays       = !sc.hasPermission(Permission.DENIED, Item.RAWBIOASSAY); 
		final boolean createRawBioAssays    =  sc.hasPermission(Permission.CREATE, Item.RAWBIOASSAY); 
		final boolean hasExperiments        = !sc.hasPermission(Permission.DENIED, Item.EXPERIMENT); 
		final boolean createExperiments     =  sc.hasPermission(Permission.CREATE, Item.EXPERIMENT); 
		final boolean hasFormulas           = !sc.hasPermission(Permission.DENIED, Item.FORMULA); 
		final boolean createFormulas        =  sc.hasPermission(Permission.CREATE, Item.FORMULA); 
		
		final boolean hasReporters          = !sc.hasPermission(Permission.DENIED, Item.REPORTER); 
		final boolean hasReporterLists      = !sc.hasPermission(Permission.DENIED, Item.REPORTERLIST); 
		final boolean createReporters       =  sc.hasPermission(Permission.CREATE, Item.REPORTER); 
		final boolean hasJobs               = !sc.hasPermission(Permission.DENIED, Item.JOB); 
		final boolean hasSessions           = !sc.hasPermission(Permission.DENIED, Item.SESSION); 
		%>
		<m:menu
			id="menu.view"
			style="display: none"
			>
			<m:menuitem
				title="<%=menu.getString("home.title")%>"
				tooltip="<%=menu.getString("home.tooltip")%>" 
				url="<%=root+"my_base/index.jsp?ID="+ID%>"
			/>
			<m:menuitem
				title="<%=menu.getString("allitems.title")%>"
				tooltip="<%=menu.getString("allitems.tooltip")%>"
				url="<%=root+"views/items/index.jsp?ID="+ID%>"
			/>
			<m:menuitem
				title="<%=menu.getString("trashcan.title")%>"
				tooltip="<%=menu.getString("trashcan.tooltip")%>"
				url="<%=root+"views/trashcan/index.jsp?ID="+ID%>"
			/>
			<m:menuseparator />
			<m:menuitem 
				title="<%=common.getString("item.file+")%>" 
				url="<%=root+"filemanager/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("files.tooltip", hasFiles)%>" 
				enabled="<%=hasFiles%>"
			/>
			<m:menuitem 
				title="<%=common.getString("item.fileserver+")%>" 
				url="<%=root+"filemanager/fileservers/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("fileservers.tooltip", hasFileServers)%>" 
				enabled="<%=hasFileServers%>"
			/>
			<m:menuitem
				title="<%=common.getString("item.project+")%>"
				url="<%=root+"my_base/projects/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("projects.tooltip", hasProjects)%>"
				enabled="<%=hasProjects%>"
			/>
			<m:menuitem
				title="<%=common.getString("item.permissiontemplate+")%>"
				url="<%=root+"views/permissiontemplates/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("permissiontemplates.tooltip", hasPermissionTemplates)%>"
				enabled="<%=hasPermissionTemplates%>"
			/>
			<m:menuitem 
				title="<%=common.getString("item.message+")%>" 
				url="<%=root+"my_base/messages/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("messages.tooltip", hasMessages)%>"
				enabled="<%=hasMessages%>"
			/>
			<m:menuitem 
				title="<%=common.getString("item.job+")%>" 
				url="<%=root+"views/jobs/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("jobs.tooltip", hasJobs)%>"
				enabled="<%=hasJobs%>"
			/>
			<m:menuitem 
				title="<%=common.getString("item.session+")%>" 
				url="<%=root+"views/sessions/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("sessions.tooltip", hasSessions)%>"
				enabled="<%=hasSessions%>"
			/>
			<m:menuseparator />
			<m:menuitem
				title="<%=common.getString("item.physicalbioassay+")%>"
				url="<%=root+"views/physicalbioassays/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("physicalbioassays.tooltip", hasPhysicalBioAssays)%>"
				enabled="<%=hasPhysicalBioAssays%>"
			/>
			<m:menuitem
				title="<%=common.getString("item.derivedbioassay+")%>"
				url="<%=root+"views/derivedbioassays/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("derivedbioassays.tooltip", hasDerivedBioAssays)%>"
				enabled="<%=hasDerivedBioAssays%>"
			/>
			<m:menuitem
				title="<%=common.getString("item.rawbioassay+")%>"
				url="<%=root+"views/rawbioassays/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("rawbioassays.tooltip", hasRawBioAssays)%>"
				enabled="<%=hasRawBioAssays%>"
			/>
			<m:menuitem
				title="<%=common.getString("item.experiment+")%>"
				url="<%=root+"views/experiments/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("experiments.tooltip", hasExperiments)%>"
				enabled="<%=hasExperiments%>"
			/>
			<m:menuitem
				title="<%=common.getString("item.formula+")%>"
				url="<%=root+"views/formulas/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("formulas.tooltip", hasFormulas)%>"
				enabled="<%=hasFormulas%>"
			/>
			<m:menuseparator />
			<m:menuitem
				title="<%=common.getString("item.reporter+")%>"
				url="<%=root+"views/reporters/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("reporters.tooltip", hasReporters)%>"
				enabled="<%=hasReporters%>"
			/>
			<m:menuitem
				title="<%=common.getString("item.reporterlist+")%>"
				url="<%=root+"views/reporterlists/index.jsp?ID="+ID%>"
				tooltip="<%=menu.getString("reporterlists.tooltip", hasReporterLists)%>"
				enabled="<%=hasReporterLists%>"
			/>
		</m:menu>

		<m:menu 
			id="menu.base" 
			style="display: none"
			>
			<m:submenu 
				subid="menu.projects" 
				title="<%=menu.getString("menu.projects")%>"
				tooltip="<%=menu.getString("menu.projects.tooltip", activeProject != null)%>"
				enabled="<%=hasProjects%>"
			/>
			<m:menuseparator />
			<m:menuitem 
				title="<%=menu.getString("contactinfo.title") + "…"%>" 
				url="<%=root+"my_base/user/settings.jsp?ID="+ID+"&amp;page=contact"%>" 
				data-popup="Settings, 600, 400" 
				tooltip="<%=menu.getString("contactinfo.tooltip")%>" 
			/>
			<m:menuitem 
				title="<%=menu.getString("password.title") + "…"%>" 
				url="<%=root+"my_base/user/settings.jsp?ID="+ID+"&amp;page=password"%>" 
				data-popup="Settings, 600, 400" 
				tooltip="<%=menu.getString("password.tooltip")%>" 
			/>
			<m:menuitem 
				title="<%=menu.getString("other.title") + "…"%>"  
				url="<%=root+"my_base/user/settings.jsp?ID="+ID+"&amp;page=other"%>"
				data-popup="Settings, 600, 400" 
				tooltip="<%=menu.getString("other.tooltip")%>" 
			/>
			<m:menuseparator />
			<m:menuitem 
				title="<%=menu.getString("preferences.title") + "…"%>" 
				url="<%=root+"my_base/user/preferences.jsp?ID="+ID%>"
				data-popup="Preferences, 600, 400" 
				tooltip="<%=menu.getString("preferences.tooltip")%>" 
			/>
			<m:menuitem 
				title="<%=menu.getString("reloadpermissions.title") + "…"%>" 
				url="<%=root+"my_base/user/submit_user.jsp?ID="+ID+"&amp;cmd=ReloadPermissions"%>"
				data-popup="ReloadPermissions, 300, 200" 
				tooltip="<%=menu.getString("reloadpermissions.tooltip")%>" 
			/>
			<m:menuitem 
				title="<%=menu.getString("resetlistsettings.title") + "…"%>" 
				url="<%=root+"my_base/user/reset_filters.jsp?ID="+ID%>"
				data-popup="ResetFilter, 450, 300" 
				tooltip="<%=menu.getString("resetlistsettings.tooltip")%>" 
			/>
			<m:menuseparator />
			<m:menuitem 
				title="<%=menu.getString("logout.title") + "…"%>" 
				url="<%=root+"logout.jsp?ID="+ID%>"
				data-popup="Logout, 300, 200"
				tooltip="<%=menu.getString("logout.tooltip")%>" 
			/>
		</m:menu>
		<%
		// BioLIMS - menu	
		final boolean hasTags             = !sc.hasPermission(Permission.DENIED, Item.TAG); 
		final boolean createTags          =  sc.hasPermission(Permission.CREATE, Item.TAG); 

		final boolean hasBioSources         = !sc.hasPermission(Permission.DENIED, Item.BIOSOURCE); 
		final boolean createBioSources      =  sc.hasPermission(Permission.CREATE, Item.BIOSOURCE); 

		final boolean hasSamples            = !sc.hasPermission(Permission.DENIED, Item.SAMPLE); 
		final boolean createSamples         =  sc.hasPermission(Permission.CREATE, Item.SAMPLE);

		final boolean hasExtracts           = !sc.hasPermission(Permission.DENIED, Item.EXTRACT); 
		final boolean createExtracts        =  sc.hasPermission(Permission.CREATE, Item.EXTRACT); 
		
		final boolean hasBioMaterialLists   = !sc.hasPermission(Permission.DENIED, Item.BIOMATERIALLIST);
		
		final boolean hasBioPlates			= !sc.hasPermission(Permission.DENIED, Item.BIOPLATE);
		final boolean createBioPlates		=  sc.hasPermission(Permission.CREATE, Item.BIOPLATE);
		final boolean hasBioPlateTypes	= !sc.hasPermission(Permission.DENIED, Item.BIOPLATETYPE);
		final boolean hasBioPlateEventTypes	= !sc.hasPermission(Permission.DENIED, Item.BIOPLATEEVENTTYPE);
		final boolean hasBioLims			=  hasTags || hasBioSources || hasSamples || hasExtracts || 
											hasBioMaterialLists || hasBioPlates || 
											hasBioPlateTypes || hasBioPlateEventTypes;
		
		if (hasBioLims)
		{
		%>
			<m:menu 
				id="menu.biolims"
				style="display: none"
				>
				<m:menuitem
					title="<%=common.getString("item.biosource+")%>"
					url="<%=root+"biomaterials/biosources/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("biosources.tooltip", hasBioSources)%>"
					enabled="<%=hasBioSources%>"
				/>
				<m:menuitem
					title="<%=common.getString("item.sample+")%>"
					url="<%=root+"biomaterials/samples/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("samples.tooltip", hasSamples)%>"
					enabled="<%=hasSamples%>"
				/>
				<m:menuitem
					title="<%=common.getString("item.extract+")%>"
					url="<%=root+"biomaterials/extracts/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("extracts.tooltip", hasExtracts)%>"
					enabled="<%=hasExtracts%>"
				/>
				<m:menuitem
					title="<%=common.getString("item.tag+")%>"
					url="<%=root+"biomaterials/tags/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("tags.tooltip", hasTags)%>"
					enabled="<%=hasTags%>"
				/>
				<m:menuseparator />
				<m:menuitem
					title="<%=common.getString("item.bioplate+")%>"
					url="<%=root+"biomaterials/bioplates/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("bioplates.tooltip", hasBioPlates)%>"
					enabled="<%=hasBioPlates%>"
				/>
				<m:menuitem
					title="<%=common.getString("item.bioplatetype+")%>"
					url="<%=root+"biomaterials/bioplatetypes/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("bioplatetypes.tooltip", hasBioPlateTypes)%>"
					enabled="<%=hasBioPlateTypes%>"
				/>
				<m:menuitem
					title="<%=common.getString("item.bioplateeventtype+")%>"
					url="<%=root+"biomaterials/bioplateeventtypes/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("bioplateeventtypes.tooltip", hasBioPlateEventTypes)%>"
					enabled="<%=hasBioPlateEventTypes%>"
				/>
				<m:menuseparator />
				<m:menuitem
					title="<%=common.getString("item.biomateriallist+")%>"
					url="<%=root+"biomaterials/lists/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("biomateriallists.tooltip", hasBioMaterialLists)%>"
					enabled="<%=hasBioMaterialLists%>"
				/>
			</m:menu>
		<%
		}
		
		// Array LIMS - menu
		final boolean hasPlateGeometries = sc.hasPermission(Permission.READ, Item.PLATEGEOMETRY);
		final boolean hasPlateTypes = !sc.hasPermission(Permission.DENIED, Item.PLATETYPE);
		final boolean hasPlates = !sc.hasPermission(Permission.DENIED, Item.PLATE);
		final boolean hasPlateMappings = !sc.hasPermission(Permission.DENIED, Item.PLATEMAPPING);
		final boolean hasArraySlides = !sc.hasPermission(Permission.DENIED, Item.ARRAYSLIDE);
		final boolean hasArrayBatches = !sc.hasPermission(Permission.DENIED, Item.ARRAYBATCH);
		final boolean hasArrayDesigns = !sc.hasPermission(Permission.DENIED, Item.ARRAYDESIGN);
		final boolean hasLims = hasPlateGeometries || hasPlateTypes || hasPlates || hasPlateMappings || 
			hasArraySlides || hasArrayBatches || hasArrayDesigns;
		if (hasLims)
		{
			%>
			<m:menu 
				id="menu.lims" 
				style="display: none"
				>
				<m:menuitem 
					title="<%=common.getString("item.plategeometry+")%>" 
					url="<%=root+"lims/geometries/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("plategeometries.tooltip", hasPlateGeometries)%>" 
					enabled="<%=hasPlateGeometries%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.platetype+")%>" 
					url="<%=root+"lims/platetypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("platetypes.tooltip", hasPlateTypes)%>" 
					enabled="<%=hasPlateTypes%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.plate+")%>" 
					url="<%=root+"lims/plates/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("plates.tooltip", hasPlates)%>" 
					enabled="<%=hasPlates%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.platemapping+")%>" 
					url="<%=root+"lims/platemappings/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("platetypes.tooltip", hasPlateTypes)%>" 
					enabled="<%=hasPlateTypes%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="<%=common.getString("item.arraydesign+")%>" 
					url="<%=root+"lims/arraydesigns/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("arraydesigns.tooltip", hasArrayDesigns)%>" 
					enabled="<%=hasArrayDesigns%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.arraybatch+")%>" 
					url="<%=root+"lims/arraybatches/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("arraybatches.tooltip", hasArrayBatches)%>" 
					enabled="<%=hasArrayBatches%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.arrayslide+")%>" 
					url="<%=root+"lims/arrayslides/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("arrayslides.tooltip", hasArraySlides)%>" 
					enabled="<%=hasArraySlides%>"
				/>
			</m:menu>
			<%
		}
		// Administrate -> Types menu
		final boolean hasQuotaTypes = sc.hasPermission(Permission.READ, Item.QUOTATYPE);
		final boolean hasMimeTypes = sc.hasPermission(Permission.READ, Item.MIMETYPE);
		final boolean hasAnnotationTypeCategories = !sc.hasPermission(Permission.DENIED, Item.ANNOTATIONTYPECATEGORY);		
		final boolean hasAnnotationTypes = !sc.hasPermission(Permission.DENIED, Item.ANNOTATIONTYPE);
		final boolean hasReporterTypes = !sc.hasPermission(Permission.DENIED, Item.REPORTERTYPE);
		final boolean hasExtraValueTypes = !sc.hasPermission(Permission.DENIED, Item.EXTRAVALUETYPE);
		final boolean hasQuantities = !sc.hasPermission(Permission.DENIED, Item.QUANTITY);
		final boolean hasItemSubtypes = sc.hasPermission(Permission.READ, Item.ITEMSUBTYPE);
		final boolean hasTypes = hasMimeTypes || hasQuotaTypes || 
			hasAnnotationTypeCategories || hasAnnotationTypes || 
			hasReporterTypes || hasExtraValueTypes || hasQuantities || hasItemSubtypes;
		if (hasTypes)
		{
			%>
			<m:menu 
				id="menu.types" 
				style="display: none"
				>
				<m:menuitem 
					title="<%=common.getString("item.itemsubtype+")%>" 
					url="<%=root+"admin/itemsubtypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("itemsubtypes.tooltip", hasItemSubtypes)%>" 
					enabled="<%=hasItemSubtypes%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="<%=common.getString("item.annotationtype+")%>" 
					url="<%=root+"admin/annotationtypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("annotationtypes.tooltip", hasAnnotationTypes)%>" 
					enabled="<%=hasAnnotationTypes%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.annotationtypecategory+")%>" 
					url="<%=root+"admin/annotationtypecategories/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("annotationtypecategories.tooltip", hasAnnotationTypeCategories)%>" 
					enabled="<%=hasAnnotationTypeCategories%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="<%=common.getString("item.mimetype+")%>" 
					url="<%=root+"admin/mimetypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("mimetypes.tooltip", hasMimeTypes)%>" 
					enabled="<%=hasMimeTypes%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.quotatype+")%>" 
					url="<%=root+"admin/quotatypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("quotatypes.tooltip", hasQuotaTypes)%>" 
					enabled="<%=hasQuotaTypes%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.reportertype+")%>" 
					url="<%=root+"admin/reportertypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("reportertypes.tooltip", hasReporterTypes)%>" 
					enabled="<%=hasReporterTypes%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.extravaluetype+")%>" 
					url="<%=root+"admin/extravaluetypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("extravaluetypes.tooltip", hasExtraValueTypes)%>" 
					enabled="<%=hasExtraValueTypes%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="<%=menu.getString("units+quantities.title")%>" 
					url="<%=root+"admin/quantities/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("units+quantities.tooltip", hasQuantities)%>" 
					enabled="<%=hasQuantities%>"
				/>
			</m:menu>
			<%
		}
		// Administrate -> Platforms menu
		final boolean hasPlatforms = sc.hasPermission(Permission.READ, Item.PLATFORM);
		final boolean hasFileSetMemberTypes = sc.hasPermission(Permission.READ, Item.DATAFILETYPE);
		final boolean hasTopPlatforms = hasPlatforms || hasFileSetMemberTypes;
		if (hasTopPlatforms)
		{
			%>
			<m:menu 
				id="menu.platforms"
				style="display: none"
				>
				<m:menuitem 
					title="<%=common.getString("item.platform+")%>"
					url="<%=root+"admin/platforms/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("platforms.tooltip", hasPlatforms)%>"
					enabled="<%=hasPlatforms%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.datafiletype+")%>"
					url="<%=root+"admin/datafiletypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("datafiletypes.tooltip", hasFileSetMemberTypes)%>"
					enabled="<%=hasFileSetMemberTypes%>"
				/>
			</m:menu>
			<%
		}
		// Plugins menu
		final boolean hasPluginTypes = !sc.hasPermission(Permission.DENIED, Item.PLUGINTYPE);
		final boolean hasPluginDefinitions = !sc.hasPermission(Permission.DENIED, Item.PLUGINDEFINITION);
		final boolean hasPluginConfigurations = !sc.hasPermission(Permission.DENIED, Item.PLUGINCONFIGURATION);
		final boolean hasJobAgents = sc.hasPermission(Permission.READ, Item.JOBAGENT);
		final boolean hasPlugins = hasPluginTypes || hasPluginDefinitions || 
			hasPluginConfigurations || hasJobAgents;
		
		if (hasPlugins)
		{
			%>
			<m:menu 
				id="menu.plugins" 
				style="display: none"
				>
				<m:menuitem
					title="<%=menu.getString("installedextensions.title")%>"
					url="<%=root+"admin/extensions/index.jsp?ID="+ID%>"
					tooltip="<%=menu.getString("installedextensions.tooltip")%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="<%=menu.getString("plugintypes.title")%>" 
					url="<%=root+"admin/plugintypes/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("plugintypes.tooltip", hasPluginTypes)%>"
					enabled="<%=hasPluginTypes%>"
				/>
				<m:menuitem 
					title="<%=menu.getString("plugindefinitions.title")%>" 
					url="<%=root+"admin/plugindefinitions/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("plugindefinitions.tooltip", hasPluginDefinitions)%>"
					enabled="<%=hasPluginDefinitions%>"
				/>
				<m:menuitem 
					title="<%=menu.getString("pluginconfigurations.title")%>" 
					url="<%=root+"admin/pluginconfigurations/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("pluginconfigurations.tooltip", hasPluginConfigurations)%>"
					enabled="<%=hasPluginConfigurations%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="<%=common.getString("item.jobagent+")%>" 
					url="<%=root+"admin/jobagents/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("jobagents.tooltip", hasJobAgents)%>"
					enabled="<%=hasJobAgents%>"
				/>
			</m:menu>
			<%
		}
		// Administrate menu
		final boolean hasUsers = !sc.hasPermission(Permission.DENIED, Item.USER);
		final boolean hasGroups = !sc.hasPermission(Permission.DENIED, Item.GROUP);
		final boolean hasRoles = sc.hasPermission(Permission.READ, Item.ROLE);
		final boolean hasQuota = sc.hasPermission(Permission.READ, Item.QUOTA);
		final boolean hasSoftware = !sc.hasPermission(Permission.DENIED, Item.SOFTWARE);
		final boolean hasHardware = !sc.hasPermission(Permission.DENIED, Item.HARDWARE);
		final boolean hasProtocols = !sc.hasPermission(Permission.DENIED, Item.PROTOCOL);
		final boolean hasClients = sc.hasPermission(Permission.READ, Item.CLIENT);
		final boolean hasNews = sc.hasPermission(Permission.READ, Item.NEWS);
		final boolean hasReporterCloneTemplates = !sc.hasPermission(Permission.DENIED, Item.REPORTERCLONETEMPLATE);
		final boolean hasDiskUsage = sc.hasPermission(Permission.READ, Item.DISKUSAGE);
		final Client currentClient = Client.getById(dc, sc.getClientId());
		final boolean hasServer = currentClient.hasPermission(Permission.WRITE);

		final boolean hasAdministrate = 
			hasUsers || hasGroups || hasRoles || hasQuota || hasTypes || hasPlugins ||
			hasSoftware || hasHardware || hasProtocols || hasClients || hasNews || hasReporterCloneTemplates || 
			hasDiskUsage || hasServer || hasTopPlatforms;

		if (hasAdministrate)
		{
			%>
			<m:menu 
				id="menu.administrate" 
				style="display: none"
				>
				<m:menuitem 
					title="<%=common.getString("item.user+")%>" 
					url="<%=root+"admin/users/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("users.tooltip", hasUsers)%>"
					enabled="<%=hasUsers%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.group+")%>" 
					url="<%=root+"admin/groups/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("groups.tooltip", hasGroups)%>" 
					enabled="<%=hasGroups%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.role+")%>" 
					url="<%=root+"admin/roles/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("roles.tooltip", hasRoles)%>" 
					enabled="<%=hasRoles%>"
				/>
				<m:menuseparator />
				<m:submenu 
					subid="menu.plugins" 
					title="<%=menu.getString("menu.plugins")%>"
					tooltip="<%=menu.getString("menu.plugins.tooltip")%>"
					enabled="<%=hasPlugins%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="<%=common.getString("item.quota+")%>" 
					url="<%=root+"admin/quota/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("quota.tooltip", hasQuota)%>" 
					enabled="<%=hasQuota%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.software+")%>" 
					url="<%=root+"admin/software/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("software.tooltip", hasSoftware)%>" 
					enabled="<%=hasSoftware%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.hardware+")%>" 
					url="<%=root+"admin/hardware/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("hardware.tooltip", hasHardware)%>" 
					enabled="<%=hasHardware%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.protocol+")%>" 
					url="<%=root+"admin/protocols/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("protocols.tooltip", hasProtocols)%>" 
					enabled="<%=hasProtocols%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.client+")%>" 
					url="<%=root+"admin/clients/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("clients.tooltip", hasClients)%>" 
					enabled="<%=hasClients%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.news+")%>" 
					url="<%=root+"admin/news/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("news.tooltip", hasNews)%>" 
					enabled="<%=hasNews%>"
				/>
				<m:menuitem 
					title="<%=common.getString("item.reporterclonetemplate+")%>" 
					url="<%=root+"admin/reporterclonetemplates/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("reporterclonetemplates.tooltip", hasReporterCloneTemplates)%>" 
					enabled="<%=hasReporterCloneTemplates%>"
				/>
				<m:menuseparator />
				<m:submenu 
					subid="menu.platforms" 
					title="<%=menu.getString("menu.platforms")%>"
					tooltip="<%=menu.getString("menu.platforms.tooltip")%>"
					enabled="<%=hasTopPlatforms%>"
				/>
				<m:submenu 
					subid="menu.types" 
					title="<%=menu.getString("menu.types")%>"
					tooltip="<%=menu.getString("menu.types.tooltip")%>"
					enabled="<%=hasTypes%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="<%=common.getString("item.diskusage+")%>" 
					url="<%=root+"admin/diskusage/index.jsp?ID="+ID%>" 
					tooltip="<%=menu.getString("diskusage.tooltip", hasDiskUsage)%>" 
					enabled="<%=hasDiskUsage%>"
				/>
				<m:menuitem 
					title="<%=menu.getString("serversettings.title")+"…"%>"
					url="<%=root+"admin/server/configure.jsp?ID="+ID%>"
					data-popup="ServerSettings, 600, 400"
					tooltip="<%=menu.getString("serversettings.tooltip", hasServer)%>"
					enabled="<%=hasServer%>"
				/>
				<m:menuitem 
					title="<%=menu.getString("broadcast.title")+"…"%>"
					url="<%=root+"admin/server/broadcast.jsp?ID="+ID%>"
					data-popup="BroadcastMessage, 600, 400"
					tooltip="<%=menu.getString("broadcast.tooltip", hasServer)%>"
					enabled="<%=hasServer%>"
				/>
				<m:menuitem
					title="<%=menu.getString("services.title")%>"
					tooltip="<%=menu.getString("services.tooltip", hasServer)%>"
					url="<%=root+"admin/services/index.jsp?ID="+ID%>"
					enabled="<%=hasServer%>"
				/>
			</m:menu>
			<%
		}
		// Help menu
		final String helplink = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.help"));
		final String faqlink = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.faq"));
		final String reportbuglink = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.reportbug"));
		%>
		<m:menu id="menu.help" style="display: none">
			<m:menuitem
				visible="<%=HTML.isValidUrl(helplink)%>"
				title="<%=menu.getString("menu.help") + "…"%>"
				url="<%=helplink%>"
				data-target="Help"
			/>
			<m:menuitem
				visible="<%=HTML.isValidUrl(faqlink)%>"
				title="<%=menu.getString("faq.title") + "…"%>"
				url="<%=faqlink%>"
				data-target="FAQ"
				tooltip="<%=menu.getString("faq.tooltip") %>"
			/>
			<m:menuseparator />

			<m:menuitem
				title="<%=menu.getString("about.title") + "…"%>"
				url="<%=root+"info/about.jsp?ID="+ID+"&amp;page=about"%>"
				data-popup="About, 600, 400"
			/>
			<m:menuitem
				title="<%=menu.getString("license.title") + "…"%>"
				url="<%=root+"info/about.jsp?ID="+ID+"&amp;page=license"%>"
				data-popup="About, 600, 400"
			/>
			<m:menuitem
				visible="<%=HTML.isValidUrl(reportbuglink)%>"
				title="<%=menu.getString("bugreport.title") + "…"%>"
				url="<%=reportbuglink%>"
				data-target="ReportBug"
				tooltip="<%=menu.getString("bugreport.tooltip")%>"
			/>
			<m:menuseparator />
			<m:menuitem
				title="<%=menu.getString("basesite.title") + "…"%>" 
				url="http://base.thep.lu.se"
				data-target="basesite"
				tooltip="<%=menu.getString("basesite.tooltip")%>"
			/>
		</m:menu>
		<%
		//Switch user/logout menu
		final boolean hasImpersonate = 
			!sc.isImpersonated() && sc.hasSystemPermission(Permission.ACT_AS_ANOTHER_USER);
		%>
		<m:menu
			id="menu.switchuser"
			style="display: none;"
			>
			<m:menuitem 
				title="<%=menu.getString("switchuser.title") + "…"%>" 
				url="<%=root+"switch.jsp?ID="+ID%>"
				data-popup="Switch, 480, 320"
				tooltip="<%=menu.getString("switchuser.tooltip")%>" 
			/>
			<m:menuitem 
				title="<%=menu.getString("impersonate.title") + "…"%>" 
				url="<%=root+"impersonate.jsp?ID="+ID%>"
				data-popup="Impersonate, 480, 320"
				tooltip="<%=menu.getString("impersonate.tooltip")%>" 
				visible="<%=hasImpersonate%>"
			/>
			<m:menuitem 
				title="<%=menu.getString("logout.title") + "…"%>" 
				url="<%=root+"logout.jsp?ID="+ID%>"
				data-popup="Logout, 360, 240"
				tooltip="<%=menu.getString("logout.tooltip")%>" 
			/>
		</m:menu>
		<%
		// Extensions menu
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext);
		ExtensionsInvoker<MenuItemAction> invoker = 
			(ExtensionsInvoker<MenuItemAction>)ExtensionsControl.useExtensions(jspContext, 
				"net.sf.basedb.clients.web.menu.extensions");
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ActionIterator<MenuItemAction> it = invoker.iterate();
		Map<String, List<MenuItemAction>> menus = new HashMap<String, List<MenuItemAction>>();
		menus.put("extensions", new LinkedList<MenuItemAction>());
		int numExtensionMenues = 0;
		while (it.hasNext())
		{
			MenuItemAction action = it.next();
			String menuId = action.getMenuId();
			menuId = menuId == null ? "extensions" : "extensions." + menuId;
			List<MenuItemAction> actions = menus.get(menuId);
			if (actions == null)
			{
				actions = new LinkedList<MenuItemAction>();
				menus.put(menuId, actions);
			}
			actions.add(action);
		}
		for (Map.Entry<String, List<MenuItemAction>> entry : menus.entrySet())
		{
			String menuId = entry.getKey();
			List<MenuItemAction> actions = entry.getValue();
			if (actions.size() == 0) continue;
			%>
			<m:menu id="<%="menu."+menuId%>" style="display: none;">
			<%
			for (MenuItemAction action : actions)
			{
				numExtensionMenues++;
				Iterator<DynamicActionAttribute> dynamicAttributes = 
					action instanceof DynamicActionAttributes ?
						((DynamicActionAttributes)action).getDynamicActionAttributes() : null;
				if (action.getType() == MenuItemAction.MenuType.SEPARATOR)
				{
					%>
					<m:menuseparator 
						id="<%=action.getId() %>"
						subclass="<%=action.getClazz() %>"
						style="<%=action.getStyle()%>" 
						visible="<%=action.isVisible()%>" 
						dynamic="<%=dynamicAttributes%>"
					/>
					<%
				}
				else if (action.getType() == MenuItemAction.MenuType.MENUITEM)
				{
					if (action.getOnClick() != null)
					{
						%>
						<m:menuitem 
							id="<%=action.getId() %>"
							subclass="<%=action.getClazz() %>"
							style="<%=action.getStyle()%>"
							title="<%=action.getTitle()%>"
							icon="<%=action.getIcon()%>"
							tooltip="<%=action.getTooltip()%>"
							enabled="<%=action.isEnabled()%>"
							visible="<%=action.isVisible()%>"
							onclick="<%=action.getOnClick()%>"
							dynamic="<%=dynamicAttributes%>"
						/>
						<%
					}
					else
					{
						%>
						<m:menuitem 
							id="<%=action.getId() %>"
							subclass="<%=action.getClazz() %>"
							style="<%=action.getStyle()%>"
							title="<%=action.getTitle()%>"
							icon="<%=action.getIcon()%>"
							tooltip="<%=action.getTooltip()%>"
							enabled="<%=action.isEnabled()%>"
							visible="<%=action.isVisible()%>"
							dynamic="<%=dynamicAttributes%>"
						/>
						<%
					}
				}
				else if (action.getType() == MenuItemAction.MenuType.SUBMENU)
				{
					%>
					<m:submenu 
						id="<%=action.getId() %>"
						subclass="<%=action.getClazz() %>"
						subid="<%="menu.extensions." + action.getSubmenuId()%>"
						style="<%=action.getStyle()%>"
						title="<%=action.getTitle()%>"
						icon="<%=action.getIcon()%>"
						tooltip="<%=action.getTooltip()%>"
						enabled="<%=action.isEnabled()%>"
						visible="<%=action.isVisible()%>"
						dynamic="<%=dynamicAttributes%>"
					/>
					<%
				}
			}
			%>
			</m:menu>
			<%
		}
		// Main menu
		%>
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<m:menu
			type="horizontal"
			id="menubar"
			style="top: 0px; left: 0px; right: 0px;"
			open="click"
			filltext="<%=fillText.toString()%>"
			>
			<m:submenu
				subid="menu.base"
				title="<%=menu.getString("menu.base")%>"
			/>
			<m:submenu
				subid="menu.view"
				title="<%=menu.getString("menu.view")%>"
			/>
			<m:submenu 
				subid="menu.biolims"
				title="<%=menu.getString("menu.biolims")%>"
			/>
			<m:submenu
				subid="menu.lims"
				title="<%=menu.getString("menu.arraylims")%>"
			/>
			<m:submenu
				subid="menu.administrate"
				title="<%=menu.getString("menu.administrate")%>"
				visible="<%=hasAdministrate%>"
			/>
			<m:submenu
				subid="menu.extensions"
				title="<%=menu.getString("menu.extensions")%>"
				visible="<%=numExtensionMenues > 0 %>"
			/>
			<m:submenu
				subid="menu.help"
				title="<%=menu.getString("menu.help")%>"
			/>
		</m:menu>
		<%
	}
	finally
	{
		if (dc != null) dc.close();
	}

}
%>


